> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Create an omnichannel subscription

POST https://rest.test.zuora.com/v1/omni-channel-subscriptions
Content-Type: application/json

Creates or updates an omnichannel subscription for a customer account.

You can also create a new customer account and assign it to the new omnichannel subscription.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/orders-and-subscriptions/omnichannel-subscriptions/post-omnichannel-subscription

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a CreateOmniChannelSubscriptionRequest.

- `externalSubscriptionId` (string, required) — The original transaction ID of the notification. This must be unique in the tenant.
- `accountId` (string, optional) — The ID of the account associated with this subscription.
- `externalTransactionReason` (string, optional) — The latest transaction reason.
- `externalSourceSystem` (string, optional) — The source app store from which the channel subscription originated. For example, Apple, Google, Roku, Amazon. **Note:** When creating a new Omnichannel subscription, `externalSourceSystem` is a required field. When updating an existing Omnichannel subscription, `externalSourceSystem` is an optional field.
- `externalState` (string, optional) — The original status from client, such as active, canceled, expired, pastDue.
- `state` (string, optional) — The common external subscription state.
- `externalProductId` (string, optional) — The product ID in the external system.
- `externalReplaceByProductId` (string, optional, nullable) — The product ID is going to replace the existing product ID in the `externalProductId` field during the subscription renewal.
- `externalInAppOwnershipType` (string, optional) — Such as purchased, family_shared.
- `externalQuantity` (integer, optional, default: 1) — The quantity of the product, must be greather than 0.
- `currency` (string, optional) — The currency code of the transaction. If not specified, get value from the Account.
- `autoRenew` (boolean, optional, default: false) — If `true`, the subscription automatically renews at the end of the term.
- `externalPurchaseDate` (string, optional) — When the App Store charged the user’s account for a purchase, restored product, subscription, or subscription renewal after a lapse. UTC time, `yyyy-mm-dd hh:mm:ss`.
- `externalActivationDate` (string, optional) — When the external subscription was activated on the external platform. UTC time, `yyyy-mm-dd hh:mm:ss`.
- `externalExpirationDate` (string, optional) — This expiration date is a static value that applies for each transaction. UTC time, `yyyy-mm-dd hh:mm:ss`.
- `externalApplicationId` (string, optional) — The external application ID.
- `externalBundleId` (string, optional) — The external bundler ID.
- `externalSubscriberId` (string, optional) — The external subscriber ID.
- `externalPrice` (double, optional) — The price in external system.
- `externalPurchaseType` (string, optional) — The external purchase type.
- `externalLastRenewalDate` (string, optional) — This last renewal date is a static value that applies for each transaction. UTC time, `yyyy-mm-dd hh:mm:ss`.
- `externalNextRenewalDate` (string, optional) — This next renewal date is a static value that applies for each transaction. UTC time, `yyyy-mm-dd hh:mm:ss`.
- `accountIdentifierField` (string, optional) — The account field used to identify the account in acountData. It could be a custom field.
- `accountData` (OmniChannelAccountData, optional) — The information of the account that you want to create while creating an omnichannel subscription.

## Response

### 200

OK

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CreateOmniChannelSubscriptionResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.
- `subscriptionId` (string, optional) — The system generated ID in Billing.
- `subscriptionNumber` (string, optional) — The system generated subscription number.
- `accountId` (string, optional) — The ID of the account associated with this subscription.
- `accountNumber` (string, optional) — The number of the account associated with this subscription.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Invalid input

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### OmniChannelAccountData

The information of the account that you want to create while creating an omnichannel subscription.

- `name` (string, required) — The name of the account.
- `currency` (string, required) — Three uppercase character currency code.
- `billToContact` (ContactInfo, required) — Contact details associated with an account.
- `accountNumber` (string, optional) — The number of the account.
- `notes` (string, optional) — The note for the account.
- `soldToContact` (ContactInfo, optional) — Contact details associated with an account.
- `customFields` (map from string to any, optional) — Container for custom fields.

### CreateOmniChannelSubscriptionResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### ContactInfo

Contact details associated with an account.

- `firstName` (string, required) — First name of the contact.
- `lastName` (string, required)
- `address1` (string, optional) — First line of the contact's address. This is often a street address or a business name.
- `address2` (string, optional) — Second line of the contact's address.
- `city` (string, optional) — City of the contact's address.
- `contactDescription` (string, optional) — A description for the contact.
- `country` (string, optional) — Country; must be a valid country name or abbreviation. If using [Zuora Tax](https://knowledgecenter.zuora.com/Zuora_Billing/Taxes/A_Zuora_Tax), you must specify a country in the bill-to contact to calculate tax.
- `county` (string, optional) — County of the contact's address.
- `customFields` (map from string to any, optional) — Container for custom fields.
- `fax` (string, optional) — Fax number of the contact.
- `homePhone` (string, optional) — Home phone number of the contact.
- `mobilePhone` (string, optional) — Mobile phone number of the contact.
- `nickname` (string, optional) — Nickname of the contact.
- `otherPhone` (string, optional) — Additional phone number of the contact. Use the `otherPhoneType` field to specify the type of phone number.
- `otherPhoneType` (enum, optional) — Specifies the type of phone number in the `otherPhone` field.
  - Allowed values: `Work`, `Mobile`, `Home`, `Other`
- `personalEmail` (string, optional) — Personal email address of the contact.
- `postalCode` (string, optional) — ZIP code or other postal code of the contact's address.
- `state` (string, optional) — State or province of the contact's address.
- `taxRegion` (string, optional) — Region defined in your taxation rules. Only applicable if you use Zuora Tax.
- `workEmail` (string, optional) — Business email address of the contact.
- `workPhone` (string, optional) — Business phone number of the contact.

## Examples

**Request**

```json
{
  "externalSubscriptionId": "original-transaction-id1",
  "accountId": "8a90b4488e602d56018e6062ff5700a3",
  "externalTransactionReason": "Purchase",
  "externalSourceSystem": "Apple",
  "externalState": "Active",
  "state": "Active",
  "externalProductId": "external-product-id-1",
  "externalInAppOwnershipType": "Purchased",
  "externalQuantity": 1,
  "currency": "USD",
  "autoRenew": true,
  "externalPurchaseDate": "2024-02-01 00:01:15",
  "externalActivationDate": "2024-02-01 00:01:15",
  "externalExpirationDate": "2024-05-01 00:01:15",
  "externalApplicationId": "004d58fca978fec3697fec4af1d10065",
  "externalBundleId": "43dcdc4562784ed8a59ece4ef7d98e57",
  "externalSubscriberId": "2466082b6d1149c184a09b15bd5be694",
  "externalPrice": 100,
  "externalPurchaseType": "Purchased",
  "externalLastRenewalDate": "2024-10-01 00:00:00",
  "externalNextRenewalDate": "2025-01-01 00:00:00"
}
```

**Response**

```json
{
  "success": true,
  "subscriptionId": "54be52bbb1b9288bbf82942e00de0000",
  "subscriptionNumber": "A-S00000001",
  "accountId": "2c98906e9288bc0b0192942dfbdc316d",
  "accountNumber": "AN_1729062894303"
}
```

**SDK Code**

```python Omnichannel Subscriptions_postOmnichannelSubscription_example
import requests

url = "https://rest.test.zuora.com/v1/omni-channel-subscriptions"

payload = {
    "externalSubscriptionId": "original-transaction-id1",
    "accountId": "8a90b4488e602d56018e6062ff5700a3",
    "externalTransactionReason": "Purchase",
    "externalSourceSystem": "Apple",
    "externalState": "Active",
    "state": "Active",
    "externalProductId": "external-product-id-1",
    "externalInAppOwnershipType": "Purchased",
    "externalQuantity": 1,
    "currency": "USD",
    "autoRenew": True,
    "externalPurchaseDate": "2024-02-01 00:01:15",
    "externalActivationDate": "2024-02-01 00:01:15",
    "externalExpirationDate": "2024-05-01 00:01:15",
    "externalApplicationId": "004d58fca978fec3697fec4af1d10065",
    "externalBundleId": "43dcdc4562784ed8a59ece4ef7d98e57",
    "externalSubscriberId": "2466082b6d1149c184a09b15bd5be694",
    "externalPrice": 100,
    "externalPurchaseType": "Purchased",
    "externalLastRenewalDate": "2024-10-01 00:00:00",
    "externalNextRenewalDate": "2025-01-01 00:00:00"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Omnichannel Subscriptions_postOmnichannelSubscription_example
const url = 'https://rest.test.zuora.com/v1/omni-channel-subscriptions';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"externalSubscriptionId":"original-transaction-id1","accountId":"8a90b4488e602d56018e6062ff5700a3","externalTransactionReason":"Purchase","externalSourceSystem":"Apple","externalState":"Active","state":"Active","externalProductId":"external-product-id-1","externalInAppOwnershipType":"Purchased","externalQuantity":1,"currency":"USD","autoRenew":true,"externalPurchaseDate":"2024-02-01 00:01:15","externalActivationDate":"2024-02-01 00:01:15","externalExpirationDate":"2024-05-01 00:01:15","externalApplicationId":"004d58fca978fec3697fec4af1d10065","externalBundleId":"43dcdc4562784ed8a59ece4ef7d98e57","externalSubscriberId":"2466082b6d1149c184a09b15bd5be694","externalPrice":100,"externalPurchaseType":"Purchased","externalLastRenewalDate":"2024-10-01 00:00:00","externalNextRenewalDate":"2025-01-01 00:00:00"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Omnichannel Subscriptions_postOmnichannelSubscription_example
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/omni-channel-subscriptions"

	payload := strings.NewReader("{\n  \"externalSubscriptionId\": \"original-transaction-id1\",\n  \"accountId\": \"8a90b4488e602d56018e6062ff5700a3\",\n  \"externalTransactionReason\": \"Purchase\",\n  \"externalSourceSystem\": \"Apple\",\n  \"externalState\": \"Active\",\n  \"state\": \"Active\",\n  \"externalProductId\": \"external-product-id-1\",\n  \"externalInAppOwnershipType\": \"Purchased\",\n  \"externalQuantity\": 1,\n  \"currency\": \"USD\",\n  \"autoRenew\": true,\n  \"externalPurchaseDate\": \"2024-02-01 00:01:15\",\n  \"externalActivationDate\": \"2024-02-01 00:01:15\",\n  \"externalExpirationDate\": \"2024-05-01 00:01:15\",\n  \"externalApplicationId\": \"004d58fca978fec3697fec4af1d10065\",\n  \"externalBundleId\": \"43dcdc4562784ed8a59ece4ef7d98e57\",\n  \"externalSubscriberId\": \"2466082b6d1149c184a09b15bd5be694\",\n  \"externalPrice\": 100,\n  \"externalPurchaseType\": \"Purchased\",\n  \"externalLastRenewalDate\": \"2024-10-01 00:00:00\",\n  \"externalNextRenewalDate\": \"2025-01-01 00:00:00\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Omnichannel Subscriptions_postOmnichannelSubscription_example
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/omni-channel-subscriptions")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"externalSubscriptionId\": \"original-transaction-id1\",\n  \"accountId\": \"8a90b4488e602d56018e6062ff5700a3\",\n  \"externalTransactionReason\": \"Purchase\",\n  \"externalSourceSystem\": \"Apple\",\n  \"externalState\": \"Active\",\n  \"state\": \"Active\",\n  \"externalProductId\": \"external-product-id-1\",\n  \"externalInAppOwnershipType\": \"Purchased\",\n  \"externalQuantity\": 1,\n  \"currency\": \"USD\",\n  \"autoRenew\": true,\n  \"externalPurchaseDate\": \"2024-02-01 00:01:15\",\n  \"externalActivationDate\": \"2024-02-01 00:01:15\",\n  \"externalExpirationDate\": \"2024-05-01 00:01:15\",\n  \"externalApplicationId\": \"004d58fca978fec3697fec4af1d10065\",\n  \"externalBundleId\": \"43dcdc4562784ed8a59ece4ef7d98e57\",\n  \"externalSubscriberId\": \"2466082b6d1149c184a09b15bd5be694\",\n  \"externalPrice\": 100,\n  \"externalPurchaseType\": \"Purchased\",\n  \"externalLastRenewalDate\": \"2024-10-01 00:00:00\",\n  \"externalNextRenewalDate\": \"2025-01-01 00:00:00\"\n}"

response = http.request(request)
puts response.read_body
```

```java Omnichannel Subscriptions_postOmnichannelSubscription_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/v1/omni-channel-subscriptions")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"externalSubscriptionId\": \"original-transaction-id1\",\n  \"accountId\": \"8a90b4488e602d56018e6062ff5700a3\",\n  \"externalTransactionReason\": \"Purchase\",\n  \"externalSourceSystem\": \"Apple\",\n  \"externalState\": \"Active\",\n  \"state\": \"Active\",\n  \"externalProductId\": \"external-product-id-1\",\n  \"externalInAppOwnershipType\": \"Purchased\",\n  \"externalQuantity\": 1,\n  \"currency\": \"USD\",\n  \"autoRenew\": true,\n  \"externalPurchaseDate\": \"2024-02-01 00:01:15\",\n  \"externalActivationDate\": \"2024-02-01 00:01:15\",\n  \"externalExpirationDate\": \"2024-05-01 00:01:15\",\n  \"externalApplicationId\": \"004d58fca978fec3697fec4af1d10065\",\n  \"externalBundleId\": \"43dcdc4562784ed8a59ece4ef7d98e57\",\n  \"externalSubscriberId\": \"2466082b6d1149c184a09b15bd5be694\",\n  \"externalPrice\": 100,\n  \"externalPurchaseType\": \"Purchased\",\n  \"externalLastRenewalDate\": \"2024-10-01 00:00:00\",\n  \"externalNextRenewalDate\": \"2025-01-01 00:00:00\"\n}")
  .asString();
```

```php Omnichannel Subscriptions_postOmnichannelSubscription_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/v1/omni-channel-subscriptions', [
  'body' => '{
  "externalSubscriptionId": "original-transaction-id1",
  "accountId": "8a90b4488e602d56018e6062ff5700a3",
  "externalTransactionReason": "Purchase",
  "externalSourceSystem": "Apple",
  "externalState": "Active",
  "state": "Active",
  "externalProductId": "external-product-id-1",
  "externalInAppOwnershipType": "Purchased",
  "externalQuantity": 1,
  "currency": "USD",
  "autoRenew": true,
  "externalPurchaseDate": "2024-02-01 00:01:15",
  "externalActivationDate": "2024-02-01 00:01:15",
  "externalExpirationDate": "2024-05-01 00:01:15",
  "externalApplicationId": "004d58fca978fec3697fec4af1d10065",
  "externalBundleId": "43dcdc4562784ed8a59ece4ef7d98e57",
  "externalSubscriberId": "2466082b6d1149c184a09b15bd5be694",
  "externalPrice": 100,
  "externalPurchaseType": "Purchased",
  "externalLastRenewalDate": "2024-10-01 00:00:00",
  "externalNextRenewalDate": "2025-01-01 00:00:00"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Omnichannel Subscriptions_postOmnichannelSubscription_example
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/omni-channel-subscriptions");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"externalSubscriptionId\": \"original-transaction-id1\",\n  \"accountId\": \"8a90b4488e602d56018e6062ff5700a3\",\n  \"externalTransactionReason\": \"Purchase\",\n  \"externalSourceSystem\": \"Apple\",\n  \"externalState\": \"Active\",\n  \"state\": \"Active\",\n  \"externalProductId\": \"external-product-id-1\",\n  \"externalInAppOwnershipType\": \"Purchased\",\n  \"externalQuantity\": 1,\n  \"currency\": \"USD\",\n  \"autoRenew\": true,\n  \"externalPurchaseDate\": \"2024-02-01 00:01:15\",\n  \"externalActivationDate\": \"2024-02-01 00:01:15\",\n  \"externalExpirationDate\": \"2024-05-01 00:01:15\",\n  \"externalApplicationId\": \"004d58fca978fec3697fec4af1d10065\",\n  \"externalBundleId\": \"43dcdc4562784ed8a59ece4ef7d98e57\",\n  \"externalSubscriberId\": \"2466082b6d1149c184a09b15bd5be694\",\n  \"externalPrice\": 100,\n  \"externalPurchaseType\": \"Purchased\",\n  \"externalLastRenewalDate\": \"2024-10-01 00:00:00\",\n  \"externalNextRenewalDate\": \"2025-01-01 00:00:00\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Omnichannel Subscriptions_postOmnichannelSubscription_example
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "externalSubscriptionId": "original-transaction-id1",
  "accountId": "8a90b4488e602d56018e6062ff5700a3",
  "externalTransactionReason": "Purchase",
  "externalSourceSystem": "Apple",
  "externalState": "Active",
  "state": "Active",
  "externalProductId": "external-product-id-1",
  "externalInAppOwnershipType": "Purchased",
  "externalQuantity": 1,
  "currency": "USD",
  "autoRenew": true,
  "externalPurchaseDate": "2024-02-01 00:01:15",
  "externalActivationDate": "2024-02-01 00:01:15",
  "externalExpirationDate": "2024-05-01 00:01:15",
  "externalApplicationId": "004d58fca978fec3697fec4af1d10065",
  "externalBundleId": "43dcdc4562784ed8a59ece4ef7d98e57",
  "externalSubscriberId": "2466082b6d1149c184a09b15bd5be694",
  "externalPrice": 100,
  "externalPurchaseType": "Purchased",
  "externalLastRenewalDate": "2024-10-01 00:00:00",
  "externalNextRenewalDate": "2025-01-01 00:00:00"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/omni-channel-subscriptions")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```